您的位置:首页 > 其它

hdu 1969 Pie (二分法)

2013-11-16 14:35 316 查看

Pie

Time Limit: 5000/1000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 3133 Accepted Submission(s): 1217


[align=left]Problem Description[/align]
My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of various sizes. F of my friends are coming to my party and each of them gets a piece of pie. This should be one piece of one pie, not several small pieces since that looks messy. This piece can be one whole pie though.

My friends are very annoying and if one of them gets a bigger piece than the others, they start complaining. Therefore all of them should get equally sized (but not necessarily equally shaped) pieces, even if this leads to some pie getting spoiled (which is better than spoiling the party). Of course, I want a piece of pie for myself too, and that piece should also be of the same size.

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and they all have the same height 1, but the radii of the pies can be different.

[align=left]Input[/align]
One line with a positive integer: the number of test cases. Then for each test case:
---One line with two integers N and F with 1 <= N, F <= 10 000: the number of pies and the number of friends.
---One line with N integers ri with 1 <= ri <= 10 000: the radii of the pies.

[align=left]Output[/align]
For each test case, output one line with the largest possible volume V such that me and my friends can all get a pie piece of size V. The answer should be given as a floating point number with an absolute error of at most 10^(-3).

[align=left]Sample Input[/align]

3
3 3
4 3 3
1 24
5
10 5
1 4 2 3 4 5 6 5 4 2

[align=left]Sample Output[/align]

25.1327
3.1416
50.2655

[align=left]Source[/align]
NWERC2006

[align=left]Recommend[/align]
wangye | We have carefully selected several similar problems for you: 1551 2446 2298 2333 1399

//31MS    328K    744 B    C++
/*

题意:
开始表示看不懂,后来才知道是给出n块pie,和f+1个人,要求没个人只能拿一块,
可以是完整的一块也可以是不完整的一块。不一定要用上全部的pie。

二分法:
奇葩的题...
假设 x 为每个人在限制条件下能得到的最大的体积的pie,有:

s[1]/x+s[2]/x+...+s
/x=f+1  //s[i]为第i块pie体积

然后再使用二分法求x,其中low=0,up=max{s[1],s[2],...,s
}

*/
#include<stdio.h>
#include<math.h>
#define eps 1e-7
//#define pi 3.14159265358979323846
#define pi acos(-1.0)
int main(void)
{
int t,n,f;
double s[10005],r;
scanf("%d",&t);
while(t--)
{
double up=0,low=0;
scanf("%d%d",&n,&f);
f+=1;
for(int i=0;i<n;i++){
scanf("%lf",&r);
s[i]=pi*r*r;
if(s[i]>up) up=s[i];
}
double mid=(up+low)/2;
while(up-low>eps){
int cnt=0;
for(int i=0;i<n;i++)
cnt+=(int)(s[i]/mid);
if(cnt>=f) low=mid;
else up=mid;
mid=(up+low)/2;
}
printf("%.4lf\n",mid);

}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: